<template>
  <q-page padding>
    <div class="bg-alt-accent-full"></div>
    <!-- content -->
    <div class="q-ma-md">
      <q-card class="primary-accent-alt rounded-border-16">
        <q-card-section>
          <div class="row reverse-wrap justify-evenly items-center">
            <div class="col-12 col-sm-8 col-md-5">
              <template v-if="requestAccess">
                <q-img
                  contain
                  src="~assets/data-points.svg"
                  style="height: 100%"
                />
              </template>
              <template v-else>
                <q-img
                  contain
                  src="~assets/data-points-linked.svg"
                  style="height: 100%"
                />
              </template>
            </div>

            <div v-if="$q.platform.is.mobile" class="col-12">
              <q-separator class="q-ma-md" dark inset />
            </div>
            <q-separator class="q-ma-md" dark inset vertical v-else />

            <template v-if="requestAccess">
              <div class="col-12 col-sm-8 col-md-5 text-white">
                <div class="column items-center q-my-md q-mx-sm">
                  <div
                    :class="
                      ($q.platform.is.mobile ? 'text-h4' : 'text-h2') +
                        ' row text-bold'
                    "
                  >
                    theNexusCodes
                  </div>
                  <div
                    :class="
                      ($q.platform.is.mobile ? 'text-h6' : 'text-h5') +
                        ' row text-grey-3'
                    "
                  >
                    Request access
                  </div>
                </div>

                <q-form class="column items-center" @submit="sendRequest">
                  <div class="row full-width bg-alt-accent-alpha-30 rounded-border-16 q-mt-sm q-px-md q-py-xs shadow-4">
                    <div class="q-mt-sm text-subtitle1 text-bold text-grey-3">
                      How do we reach out to you?
                    </div>
                    <div class="row justify-center full-width q-mt-md q-mb-sm">
                    <q-input
                      dark
                      filled
                      color="grey-3"
                      class="col-10 col-md-5"
                      v-model="email"
                      label="E-Mail ID *"
                      :rules="[val => !!val || 'Email is required']"
                    />
                    </div>
                  </div>

                  <div class="row full-width bg-alt-accent-alpha-30 rounded-border-16 q-mt-sm q-px-md q-py-xs shadow-4">
                    <div class="q-mt-sm text-subtitle1 text-bold text-grey-3">
                      How do you plan on using theNexusCodes?
                    </div>
                    <div
                      class="row justify-center items-center q-gutter-sm q-mb-sm"
                    >
                      <template v-for="(use, index) in useCases">
                        <q-checkbox
                          :key="index"
                          class="col-10 col-sm-6 col-md-4"
                          dark
                          v-model="how"
                          :val="use.val"
                          :label="use.label"
                        />
                      </template>
                    </div>
                  </div>

                  <div class="row full-width bg-alt-accent-alpha-30 rounded-border-16 q-mt-sm q-px-md q-py-xs shadow-4">
                    <div class="row q-mt-sm text-subtitle1 text-bold text-grey-3">
                      Which digital products, or websites do you use frequently?
                    </div>
                    <div class="row justify-center full-width q-mb-sm">
                      <div
                        class="col-9 col-md-5 q-ma-xs"
                        v-for="n in productQty"
                        :key="n"
                      >
                        <q-input
                          dark
                          filled
                          color="grey-3"
                          style="width: 100%"
                          label="Product name, or URL"
                          v-model="products[n - 1]"
                        />
                      </div>
                      <div class="col-1 col-md-1 self-center">
                        <q-btn
                          round
                          icon="add"
                          color="accent"
                          @click="productQty++"
                        />
                      </div>
                    </div>
                  </div>

                  <div class="row full-width bg-alt-accent-alpha-30 rounded-border-16 q-mt-sm q-px-md q-py-xs shadow-4">
                    <div class="row q-mt-sm text-subtitle1 text-bold text-grey-3">
                      Tell us about your interaction with these products, or anything else.
                    </div>
                    <div class="row justify-center full-width q-my-sm">
                      <div class="col-10">
                        <q-input
                          dark
                          filled
                          autogrow
                          style="height: 100%"
                          color="grey-3"
                          label="Any other comments."
                          v-model="comments"
                        />
                      </div>
                    </div>
                  </div>

                  <div class="row full-width justify-center q-ma-md">
                    <div class="col-12 row justify-end">
                      <q-btn
                        no-caps
                        color="ctrl-primary"
                        text-color="black"
                        type="submit"
                        label="Send"
                      />
                    </div>
                  </div>
                </q-form>
              </div>
            </template>
            <template v-else>
              <div
                class="col-12 col-sm-8 col-md-5 column items-center q-my-md q-mx-sm"
              >
                <div
                  :class="
                    ($q.platform.is.mobile ? 'text-h4' : 'text-h2') +
                      ' row text-bold text-white text-center'
                  "
                >
                  Thank you for registering. We will get back to you within 48 hours.
                </div>
                <div
                  :class="
                    ($q.platform.is.mobile ? 'text-h6' : 'text-h5') +
                      ' row justify-center text-grey-3 text-center'
                  "
                >
                  If you have any questions then reach out to us on&nbsp;
                  <a class="text-white" href="mailto:care@rebhu.com">
                    care@rebhu.com
                  </a>
                </div>
              </div>
            </template>
          </div>
        </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api';
export default defineComponent({
  name: 'PagePequestAccess',

  data() {
    return {
      how: [],
      email: '',
      productQty: 1,
      products: [],
      useCases: [
        {
          val: 'planning',
          label: 'Strategy and Planning'
        },
        {
          val: 'research',
          label: 'Topic Research'
        },
        {
          val: 'history',
          label: 'Using Your Digital History'
        },
        // {
        //   val: 'journalism',
        //   label: 'Journalism and Investigations'
        // },
        // {
        //   val: 'ref',
        //   label: 'Creating reference material'
        // },
        {
          val: 'other',
          label: 'Something else (Please specify)'
        }
      ],
      // interaction: '',
      comments: '',
      requestAccess: true
    };
  },

  methods: {
    sendRequest: function() {
      const request = {
        email: this.email,
        source: window.location.host,
        meta_data: JSON.stringify({
          products: this.products,
          how: this.how,
          // interaction: this.interaction,
          comments: this.comments
        })
      };

      this.$axios
        .post('/api/register', request)
        .then(response => {
          if (response) {
            this.requestAccess = !this.requestAccess;
          }
        })
        .catch(error => {
          console.log(error);
        });
    }
  }
});
</script>
